VERSION 5.00
Begin VB.Form Main 
   Caption         =   "ReceiveMsg"
   ClientHeight    =   4290
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   9225
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4290
   ScaleWidth      =   9225
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer StatusTimer 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   120
      Top             =   3960
   End
   Begin VB.ListBox MsgList 
      Height          =   2985
      Left            =   120
      TabIndex        =   11
      Top             =   1080
      Width           =   9015
   End
   Begin VB.CommandButton Exit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   7440
      TabIndex        =   10
      Top             =   120
      Width           =   1695
   End
   Begin VB.CommandButton ClearList 
      Caption         =   "Clear List"
      Height          =   375
      Left            =   5520
      TabIndex        =   9
      Top             =   600
      Width           =   1695
   End
   Begin VB.CommandButton Receive 
      Caption         =   "Receive"
      Height          =   375
      Left            =   5520
      TabIndex        =   8
      Top             =   120
      Width           =   1695
   End
   Begin VB.CommandButton ClearStatus 
      Caption         =   "Clear Status"
      Height          =   375
      Left            =   3600
      TabIndex        =   7
      Top             =   600
      Width           =   1695
   End
   Begin VB.TextBox StatusText 
      Alignment       =   2  'Center
      Enabled         =   0   'False
      Height          =   285
      Left            =   4200
      TabIndex        =   6
      Text            =   "0x00"
      Top             =   120
      Width           =   1095
   End
   Begin VB.CommandButton Active 
      Caption         =   " Active  Board"
      Height          =   855
      Left            =   2280
      TabIndex        =   4
      Top             =   120
      Width           =   1095
   End
   Begin VB.ComboBox Baud 
      Height          =   315
      ItemData        =   "ReceiveMsg.frx":0000
      Left            =   960
      List            =   "ReceiveMsg.frx":001C
      TabIndex        =   3
      Text            =   "Combo2"
      Top             =   600
      Width           =   1215
   End
   Begin VB.ComboBox BoardNo 
      Height          =   315
      ItemData        =   "ReceiveMsg.frx":0099
      Left            =   960
      List            =   "ReceiveMsg.frx":00CD
      TabIndex        =   2
      Text            =   "Combo1"
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "Status:"
      Height          =   255
      Left            =   3600
      TabIndex        =   5
      Top             =   160
      Width           =   495
   End
   Begin VB.Label Label2 
      Caption         =   "Baud Rate:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   640
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Board No:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   160
      Width           =   735
   End
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public SelectedBoardNo As Byte, MaxListCnt As Byte
Public IsActiveFlag As Boolean

Private Sub Active_Click()
    Dim TempBoardNo As Byte, TempBaud As Byte
    Dim Ret As Integer
    Dim Para As ConfigStruct
    Dim MappedBaud(7) As String
    
    MappedBaud(0) = "10"
    MappedBaud(1) = "20"
    MappedBaud(2) = "50"
    MappedBaud(3) = "125"
    MappedBaud(4) = "250"
    MappedBaud(5) = "500"
    MappedBaud(6) = "800"
    MappedBaud(7) = "1000"
    TempBoardNo = BoardNo.ListIndex
    TempBaud = Baud.ListIndex
    If IsActiveFlag = True Then
        StatusTimer.Enabled = False 'Stop timer event
        Ret = CM100_CloseBoard(SelectedBoardNo)
        IsActiveFlag = False
    End If
    
    Ret = CM100_ActiveBoard(BoardNo) 'Active board
    If Ret <> 0 Then
        MsgBox "Active Board Error!", vbOKOnly, "Error"
        Main.Caption = "ReceiveMsg --- No board is active"
        Exit Sub
    End If

    Ret = CM100_Init(BoardNo, 1) 'Init board
    If Ret <> 0 Then
        MsgBox "Init Board Error!", vbOKOnly, "Error"
        Ret = CM100_CloseBoard(BoardNo)
        Main.Caption = "ReceiveMsg --- No board is active"
        Exit Sub
    End If

    Para.AccMask(0) = &HFF 'Set AccMask to 0xffffffff to pass all CAN messages from CAN bus
    Para.AccMask(1) = &HFF
    Para.AccMask(2) = &HFF
    Para.AccMask(3) = &HFF
    Para.AccCode(0) = &H0 'AccCode is useless when AccMask is 0xffffffff
    Para.AccCode(1) = &H0
    Para.AccCode(2) = &H0
    Para.AccCode(3) = &H0
    Para.BaudRate = TempBaud + 1 'Baud=0 for user-defined baud, 1:10K, 2:20K, 3:50K, 4:125K, 5:250K, 6:500K, 7:800K, 8:1M bps
    Para.BT0 = 0 'BT0 and BT1 are only useful when user-defined baud is used.
    Para.BT1 = 0
    Ret = CM100_Config(BoardNo, 1, Para) 'Configure board parameters
    If Ret <> 0 Then
        MsgBox "Configure Board Error!", vbOKOnly, "Error"
        Ret = CM100_CloseBoard(BoardNo)
        Main.Caption = "ReceiveMsg --- No board is active"
        Exit Sub
    End If
    SelectedBoardNo = TempBoardNo
    Main.Caption = "ReceiveMsg --- Board " + Trim(Str(SelectedBoardNo)) + _
                   " is active with baud " + MappedBaud(TempBaud) + " K pbs"
    IsActiveFlag = True
    StatusTimer.Enabled = True 'Start timer event per 500 ms
End Sub

Private Sub ClearList_Click()
    MsgList.Clear
    MaxListCnt = 0
End Sub

Private Sub ClearStatus_Click()
    Dim Ret As Integer
    
    Ret = CM100_ClearDataOverrun(SelectedBoardNo, 1)
End Sub

Private Sub Exit_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    IsActiveFlag = False
    MaxListCnt = 0
    BoardNo.ListIndex = 0
    Baud.ListIndex = 0
End Sub

Private Sub Form_Unload(Cancel As Integer)
    Dim Ret As Integer
    
    StatusTimer.Enabled = False
    If IsActiveFlag = True Then Ret = CM100_CloseBoard(SelectedBoardNo)
End Sub

Private Sub Receive_Click()
    Dim i As Integer, j As Integer, MsgCnt As Integer, Ret As Integer
    Dim Timestamp As Double
    Dim TempStr As String
    Dim CANMsg As PacketStruct

    MsgCnt = CM100_RxMsgCount(SelectedBoardNo, 1) 'Check the numbers of received CAN messages
    For i = 0 To MsgCnt - 1
        Ret = CM100_ReceiveMsg(SelectedBoardNo, 1, CANMsg) 'Receive CAN message
        If Ret <> 0 Then
            MsgBox "Get Message Error, Error code=" + Trim(Str(Ret)), vbOKOnly, "Error"
            Exit For
        End If
        Timestamp = CANMsg.MsgTimeStamps.HighLong
        Timestamp = Timestamp * 4294967296# + CANMsg.MsgTimeStamps.LowLong
        If CANMsg.RTR <> 0 Then 'if rtr bit is set, data is useless
            TempStr = "<" + Format(MaxListCnt, "000") + ">" + " Time=" + _
                      Format((Timestamp / 10), "00000000.0") + "ms, Mode:" + _
                      Trim(Str(CANMsg.Mode)) + ", ID:" + Trim(Hex(CANMsg.Id)) + _
                      ", RTR:" + Trim(Str(CANMsg.RTR)) + ", DLen:" + Trim(Str(CANMsg.Dlen))
        Else
            TempStr = "<" + Format(MaxListCnt, "000") + ">" + " Time=" + _
                      Format((Timestamp / 10), "00000000.0") + "ms, Mode:" + _
                      Trim(Str(CANMsg.Mode)) + ", ID:" + Trim(Hex(CANMsg.Id)) + _
                      ", RTR:" + Trim(Str(CANMsg.RTR)) + ", DLen:" + Trim(Str(CANMsg.Dlen)) + _
                      ", Data(hex):"
            If CANMsg.Dlen = 0 Then
                TempStr = TempStr + " X"
            Else
                TempStr = TempStr + "["
                For j = 0 To CANMsg.Dlen - 1
                    If j < CANMsg.Dlen - 1 Then
                        TempStr = TempStr + Trim(Hex(CANMsg.Data(j))) + ","
                    Else
                        TempStr = TempStr + Trim(Hex(CANMsg.Data(j)))
                    End If
                Next
                TempStr = TempStr + "]"
            End If
        End If
        MsgList.AddItem TempStr, MsgList.ListCount
        MaxListCnt = MaxListCnt + 1
        If MaxListCnt = 255 Then 'If ListBox buffer is full, clean it
            MaxListCnt = 0
            MsgList.Clear
        End If
    Next
End Sub

Private Sub StatusTimer_Timer()
    Dim CANStatus As Byte
    Dim Ret As Integer
    
    Ret = CM100_Status(SelectedBoardNo, 1, CANStatus) 'Get CAN status
    If CANStatus < 16 Then
        StatusText.Text = "0x0" + Trim(Hex(CANStatus))
    Else
        StatusText.Text = "0x" + Trim(Hex(CANStatus))
    End If
End Sub
